/*
 * Temperature3.c
 *
 * Created: 11.03.2014 9:24:14
 * Author: Admin
 */

#include <mega8515.h>
/*#asm  
  //.equ __w1_port=0x12; PORTD
  //.equ __w1_bit=2 
#endasm */
#include <1wire.h>      //    1wire
#include <ds18b20.h>    //    ds18b20
#include <delay.h>
#define MAX_DS18b20 2

//numbers 
flash char digits[] = {
0b11111010,         //0
0b00100010,         //1 
0b10111001,         //2
0b10101011,         //3
0b01100011,         //4
0b11001011,         //5
0b11011011,         //6
0b10100010,         //7 
0b11111011,         //8
0b11101011         //9
};
/*
DDRC=0b10000000;    //TOP
DDRC=0b00100000;    //TOP_RIGHT
DDRC=0b01000000;    //TOP_LEFT
DDRC=0b00000001;    //CENTER 
DDRC=0b00000010;    //BOT_RIGHT
DDRC=0b00001000;    //BOT
DDRC=0b00010000;    //BOT_LEFT 
DDRC=0b00000100;    //POINT 
*/
    
signed int tmp,cur_dig;
unsigned char devices;
unsigned char rom_code[MAX_DS18b20][9];

void setNum(int num){
    DDRC=digits[num];
}

interrupt [8] void timer0_overflow(void)  //     T0     .
{
    if(tmp>-1 && tmp<10){ 
        setNum(tmp); 
        PORTA=0b00000001;
    }
    else if(tmp>=10 && tmp<100){
        if(cur_dig==0){
            setNum(tmp%10);
            PORTA=0b00000001;
        }
        else { 
            setNum(tmp/10);
            PORTA=0b00000010;
        }
        cur_dig++; 
        if(cur_dig>1)
            cur_dig=0;
    }
    else if(tmp>=100 && tmp<1000) {
        if(cur_dig==0){
            setNum(tmp%100%10);
            PORTA=0b00000001;
        }
        else if(cur_dig==1){
            setNum(tmp%100/10);
            PORTA=0b00000010;
        }
        else { 
            setNum(tmp/100);
            PORTA=0b00000100;
        }
        cur_dig++; 
        if(cur_dig>2)
            cur_dig=0;
    }
    else
        if(tmp!=-9999) {
            DDRC=0b00000001;
            PORTA=0b00000100;
        } 
        else
        {
            DDRC=0b00000001;
            PORTA=0b00000111;
        }
}

void main( void )
{
    w1_init();
    
    cur_dig=0;       
                    
    //TCCR0 |= 0b00000010; /* 00000101 - 1/1024 ;  00000100 - 1/256 ;  00000011 - 1/64 ;  00000010 - 1/8 ;
    //                        00000001 - 1/1 ( ) ;  00000000 -  . */
    /*SREG |= 0b10000000;
    TIMSK |= 0b00000010;
    SFIOR = 0b00000001; 
    TCNT0 = 0;*/
    
    
    DDRA=0xFF;
    PORTA=0xFF; 
    
    PORTC=0;
    DDRC=0xFF;
    delay_ms(200);  
    
    PORTA=0b00000111;
    #asm("cli");      
        devices=w1_search(0xf0,rom_code);
    #asm("sei");
    delay_ms(1000);
     
    while(1)
    {
        #asm("cli");          
            tmp = ds18b20_temperature(&rom_code[0][0]);
        #asm("sei");
        delay_ms(1000);
        if(tmp==-9999)
            DDRC=0b1001001;
        else if(tmp<10)
            setNum(0);
        else if(tmp<20)
            setNum(1); 
        else if(tmp<30)
            setNum(2);
        else if(tmp<40)
            setNum(3);
        else if(tmp<50)
            setNum(4);
        else if(tmp<60)
            setNum(5);
        else if(tmp<70)
            setNum(6);
        else if(tmp<80)
            setNum(8); 
        else if(tmp<90)
            setNum(9);
        else if(tmp<100)
            DDRC=0b00001000;
        else if(tmp<110)
            DDRC=0b10000000;
    }
}